package org.jboss.security;

package .tmp;

import java.security.Principal;
import java.security.PrivilegedAction;
import javax.security.auth.Subject;
import org.jboss.security.SecurityAssociation;
import org.jboss.security.SecurityAssociationActions;

class SetPrincipalInfoAction implements PrivilegedAction {
  Principal principal;
  
  Object credential;
  
  Subject subject;
  
  SetPrincipalInfoAction(Principal principal, Object credential, Subject subject) {
    this.principal = principal;
    this.credential = credential;
    this.subject = subject;
  }
  
  public Object run() {
    SecurityAssociation.pushSubjectContext(this.subject, this.principal, this.credential);
    this.credential = null;
    this.principal = null;
    this.subject = null;
    return null;
  }
}
